
***********************************************************************
* 第四章 正文表3 对连续性条件的检验
***********************************************************************

cd "D:\2024-00330+数据\2024-00330+论文数据"

use 实证分析数据_2015人口普查数据.dta,clear

*  “均值”的连续性检验
*           局部线性回归
foreach v in "户主" "性别" "民族" "受教育程度" "识字" "流动人口" "_1年前常住地为本地" "_5年前常住地为本地" "已婚有配偶" "有农村土地承包权" "家庭人数" "去年有人出生" "去年有人死亡" "房屋面积" "房屋房间数" "_10层以上楼房" "_2000年后建成住房" "有厨房" "有厕所" "购买的住房" "有汽车" {
areg `v' Over35 DistanceFrom35 Over35_DistanceFrom35 if abs(DistanceFrom35)<=45, abs(区县代码) cluster(区县代码)
eststo
}
cd "D:\2024-00330+数据\2024-00330+日志文件"
esttab, ar2 se b(%9.4f) t(%9.4f) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码10结果_正文表3_均值检验_局部线性回归.csv, replace
estimate drop est*

*           局部二次项回归
foreach v in "户主" "性别" "民族" "受教育程度" "识字" "流动人口" "_1年前常住地为本地" "_5年前常住地为本地" "已婚有配偶" "有农村土地承包权" "家庭人数" "去年有人出生" "去年有人死亡" "房屋面积" "房屋房间数" "_10层以上楼房" "_2000年后建成住房" "有厨房" "有厕所" "购买的住房" "有汽车" {
areg `v' Over35 DistanceFrom35 Over35_DistanceFrom35 DistanceFrom35_sq Over35_DistanceFrom35_sq if abs(DistanceFrom35)<=58, abs(区县代码) cluster(区县代码)
eststo
}
esttab, ar2 se b(%9.4f) t(%9.4f) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码10结果_正文表3_均值检验_局部二次项回归.csv, replace
estimate drop est*

*  “标准差”的连续性检验
*           根据“区县—驱动变量”分组，计算各组个体和家庭特征的标准差
foreach v in "户主" "性别" "民族" "受教育程度" "识字" "流动人口" "_1年前常住地为本地" "_5年前常住地为本地" "已婚有配偶" "有农村土地承包权" "家庭人数" "去年有人出生" "去年有人死亡" "房屋面积" "房屋房间数" "_10层以上楼房" "_2000年后建成住房" "有厨房" "有厕所" "购买的住房" "有汽车" {
bys 区县代码 DistanceFrom35: egen  sd_`v'=sd(`v')
}
duplicates drop 区县代码 DistanceFrom35,force

*           局部线性回归
foreach v in "户主" "性别" "民族" "受教育程度" "识字" "流动人口" "_1年前常住地为本地" "_5年前常住地为本地" "已婚有配偶" "有农村土地承包权" "家庭人数" "去年有人出生" "去年有人死亡" "房屋面积" "房屋房间数" "_10层以上楼房" "_2000年后建成住房" "有厨房" "有厕所" "购买的住房" "有汽车" {
areg sd_`v' Over35 DistanceFrom35 Over35_DistanceFrom35 if abs(DistanceFrom35)<=45, abs(区县代码) cluster(区县代码)
eststo
}
esttab, ar2 se b(%9.4f) t(%9.4f) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码10结果_正文表3_标准差检验_局部线性回归.csv, replace
estimate drop est*

*           局部二次项回归
foreach v in "户主" "性别" "民族" "受教育程度" "识字" "流动人口" "_1年前常住地为本地" "_5年前常住地为本地" "已婚有配偶" "有农村土地承包权" "家庭人数" "去年有人出生" "去年有人死亡" "房屋面积" "房屋房间数" "_10层以上楼房" "_2000年后建成住房" "有厨房" "有厕所" "购买的住房" "有汽车" {
areg sd_`v' Over35 DistanceFrom35 Over35_DistanceFrom35 DistanceFrom35_sq Over35_DistanceFrom35_sq if abs(DistanceFrom35)<=58, abs(区县代码) cluster(区县代码)
eststo
}

esttab, ar2 se b(%9.4f) t(%9.4f) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码10结果_正文表3_标准差检验_局部二次项回归.csv, replace

*  说明：将上述结果汇总得到正文表3
*        对于"是否购买的住房"估计系数是0.0000的情况，保留5位小数
