
***********************************************************************
* 第四章 附录III表III3 安慰剂检验：替换被解释变量
***********************************************************************

cd "D:\2024-00330+数据\2024-00330+论文数据"

use 实证分析数据_2015人口普查数据.dta,clear

*  构造其他被解释变量
gen 因丧失工作能力未工作=0
replace 因丧失工作能力未工作=1 if 失业原因=="2"
replace 因丧失工作能力未工作=因丧失工作能力未工作*100

gen 因本人原因失去工作=0
replace 因本人原因失去工作=1 if 失业原因=="5"
replace 因本人原因失去工作=因本人原因失去工作*100

gen 因料理家务未工作=0
replace 因料理家务未工作=1 if 失业原因=="8"
replace 因料理家务未工作=因料理家务未工作*100

gen 在校学习=0
replace 在校学习=1 if 失业原因=="1"
replace 在校学习=在校学习*100

gen 毕业后未工作=0
replace 毕业后未工作=1 if 失业原因=="3"
replace 毕业后未工作=毕业后未工作*100

gen 承包土地被征用=0
replace 承包土地被征用=1 if 失业原因=="6"
replace 承包土地被征用=承包土地被征用*100

gen 离退休=0
replace 离退休=1 if 失业原因=="7"
replace 离退休=离退休*100

*      不含控制变量
*          局部线性回归
foreach 不同失业原因 in "因丧失工作能力未工作" "因本人原因失去工作" "因料理家务未工作" "在校学习" "毕业后未工作" "承包土地被征用" "离退休"{
areg `不同失业原因' Over35 DistanceFrom35 Over35_DistanceFrom35 if abs(DistanceFrom35)<=45, abs(区县代码) cluster(区县代码)
eststo
}
cd "D:\2024-00330+数据\2024-00330+日志文件"
esttab, ar2 se b(%9.4f) t(%9.4f) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码14结果_附录III表III3_panelA_局部线性回归.csv, replace
estimate drop est*
*          局部二次项回归
foreach 不同失业原因 in "因丧失工作能力未工作" "因本人原因失去工作" "因料理家务未工作" "在校学习" "毕业后未工作" "承包土地被征用" "离退休"{
areg `不同失业原因' Over35 DistanceFrom35 Over35_DistanceFrom35 DistanceFrom35_sq Over35_DistanceFrom35_sq if abs(DistanceFrom35)<=58, abs(区县代码) cluster(区县代码)
eststo
}
esttab, ar2 se b(%9.4f) t(%9.4f) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码14结果_附录III表III3_panelA_局部二次项回归.csv, replace
estimate drop est*

*      纳入个人和家庭特征
*          局部线性回归
foreach 不同失业原因 in "因丧失工作能力未工作" "因本人原因失去工作" "因料理家务未工作" "在校学习" "毕业后未工作" "承包土地被征用" "离退休"{
areg `不同失业原因' Over35 DistanceFrom35 Over35_DistanceFrom35 户主 性别 民族 受教育程度 识字 流动人口 _1年前常住地为本地 _5年前常住地为本地 已婚有配偶 有农村土地承包权 家庭人数 去年有人出生 去年有人死亡 房屋面积 房屋房间数 _10层以上楼房 _2000年后建成住房 有厨房 有厕所 购买的住房 有汽车 if abs(DistanceFrom35)<=45, abs(区县代码) cluster(区县代码)
eststo
}
esttab, ar2 se b(%9.4f) t(%9.4f) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码14结果_附录III表III3_panelB_局部线性回归.csv, replace
estimate drop est*
*          局部二次项回归
foreach 不同失业原因 in "因丧失工作能力未工作" "因本人原因失去工作" "因料理家务未工作" "在校学习" "毕业后未工作" "承包土地被征用" "离退休"{
areg `不同失业原因' Over35 DistanceFrom35 Over35_DistanceFrom35 DistanceFrom35_sq Over35_DistanceFrom35_sq 户主 性别 民族 受教育程度 识字 流动人口 _1年前常住地为本地 _5年前常住地为本地 已婚有配偶 有农村土地承包权 家庭人数 去年有人出生 去年有人死亡 房屋面积 房屋房间数 _10层以上楼房 _2000年后建成住房 有厨房 有厕所 购买的住房 有汽车 if abs(DistanceFrom35)<=58, abs(区县代码) cluster(区县代码)
eststo
}
esttab, ar2 se b(%9.4f) t(%9.4f) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码14结果_附录III表III3_panelB_局部二次项回归.csv, replace
estimate drop est*
