
***********************************************************************
* 第四章 附录II图II2  稳健性检验：排除年龄操纵影响
***********************************************************************

cd "D:\2024-00330+数据\2024-00330+论文数据"

use 实证分析数据_2015人口普查数据.dta,clear

* 为缓解对35岁两侧存在年龄操纵的担忧，分别剔除距离35岁最近的2、4、6、8、10、12个月样本，
* 重新执行正文表2回归，将得到的Over35系数及其90%置信区间绘制于附录III图III2

*  i=0 时，j=-1，对应基准回归结果
*  i=1 时，j=-2, 回归样本：[-45, -2] & [1, 45] 即剔除[-1,0]——最邻近35岁2个月的样本 
*  i=2 时，j=-3, 回归样本：[-45, -3] & [2, 45] 即剔除[-2,1]——最邻近35岁4个月的样本 
*  i=3 时，j=-4, 回归样本：[-45, -4] & [3, 45] 即剔除[-3,2]——最邻近35岁6个月的样本 
*  i=4 时，j=-5, 回归样本：[-45, -5] & [4, 45] 即剔除[-4,3]——最邻近35岁8个月的样本 
*  i=5 时，j=-6, 回归样本：[-45, -6] & [5, 45] 即剔除[-5,4]——最邻近35岁10个月的样本 
*  i=6 时，j=-7, 回归样本：[-45, -7] & [6, 45] 即剔除[-6,5]——最邻近35岁12个月的样本 

*  对表2第(1)列局部线性回归（不含控制变量）进行检验
forvalue i=0(1)6{
local j = -`i'-1
areg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 if abs(DistanceFrom35)<=45 & (DistanceFrom35<=`j' | DistanceFrom35>=`i'), abs(区县代码) cluster(区县代码)
eststo
}
cd "D:\2024-00330+数据\2024-00330+日志文件"
esttab, ar2  b(%9.4f) t(%9.4f) ci level(90) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码7结果_附录II图II2_表2第1列.csv, replace
estimate drop est*

*  对表2第(2)列局部线性回归（加入控制变量）进行检验
forvalue i=0(1)6{
local j = -`i'-1
areg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 户主 性别 民族 受教育程度 识字 流动人口 _1年前常住地为本地 _5年前常住地为本地 已婚有配偶 有农村土地承包权 家庭人数 去年有人出生 去年有人死亡 房屋面积 房屋房间数 _10层以上楼房 _2000年后建成住房 有厨房 有厕所 购买的住房 有汽车 if abs(DistanceFrom35)<=45 & (DistanceFrom35<=`j' | DistanceFrom35>=`i'), abs(区县代码) cluster(区县代码)
eststo
}
esttab, ar2  b(%9.4f) t(%9.4f) ci level(90) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码7结果_附录II图II2_表2第2列.csv, replace
estimate drop est*

*  对表2第(3)列局部二次项回归（不含控制变量）进行检验
local bandwith_quadratic=58
forvalue i=0(1)6{
local j = -`i'-1

areg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 DistanceFrom35_sq Over35_DistanceFrom35_sq if abs(DistanceFrom35)<=58 & (DistanceFrom35<=`j' | DistanceFrom35>=`i'), abs(区县代码) cluster(区县代码)
eststo
}
esttab, ar2  b(%9.4f) t(%9.4f) ci level(90) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码7结果_附录II图II2_表2第3列.csv, replace
estimate drop est*

*  对表2第(4)列局部二次项回归（加入控制变量）进行检验
forvalue i=0(1)6{
local j = -`i'-1
areg 是否因为单位原因失业 Over35 DistanceFrom35 Over35_DistanceFrom35 DistanceFrom35_sq Over35_DistanceFrom35_sq 户主 性别 民族 受教育程度 识字 流动人口 _1年前常住地为本地 _5年前常住地为本地 已婚有配偶 有农村土地承包权 家庭人数 去年有人出生 去年有人死亡 房屋面积 房屋房间数 _10层以上楼房 _2000年后建成住房 有厨房 有厕所 购买的住房 有汽车 if abs(DistanceFrom35)<=58 & (DistanceFrom35<=`j' | DistanceFrom35>=`i'), abs(区县代码) cluster(区县代码)
eststo
}
esttab, ar2  b(%9.4f) t(%9.4f) ci level(90) star(* 0.10 ** 0.05 *** 0.01) nogap, using 第四章_代码7结果_附录II图II2_表2第4列.csv, replace
estimate drop est*

*  汇总上述回归得到的Over35估计系数、90%置信区间，保存至附录II图II2_稳健性检验_排除年龄操纵影响.dta文件

*  利用附录II图II2_稳健性检验_排除年龄操纵影响.dta文件，绘制附录III图III2

cd "D:\2024-00330+数据\2024-00330+论文数据"
use 附录II图II2_稳健性检验_排除年龄操纵影响.dta,clear

*  对表2第(1)列局部线性回归（不含控制变量）进行检验
twoway (scatter coef drop if linear == 1 & control ==0)( rcap  up down drop if linear == 1 & control ==0), title(`"{fontface "仿宋":表2第(1)列}"') yscale(range(-0.2 0.6)) ylabel(-0.2(0.2)0.6) yline(0)  xlabel(0(2)12)  legend(off)
graph save "第四章_代码7结果_附录II图II2_表2第1列.gph"

*  对表2第(2)列局部线性回归（加入控制变量）进行检验
twoway (scatter coef drop if linear == 1 & control ==1)( rcap  up down drop if linear == 1 & control ==1), title(`"{fontface "仿宋":表2第(2)列}"') yscale(range(-0.2 0.6)) ylabel(-0.2(0.2)0.6) yline(0)  xlabel(0(2)12)   
graph save "第四章_代码7结果_附录II图II2_表2第2列.gph"

*  对表2第(3)列局部二次项回归（不含控制变量）进行检验
twoway (scatter coef drop if linear == 0 & control ==0)( rcap  up down drop if linear == 0 & control ==0), title(`"{fontface "仿宋":表2第(3)列}"') yscale(range(-0.2 0.6)) ylabel(-0.2(0.2)0.6) yline(0)  xlabel(0(2)12)  legend(off)
graph save "第四章_代码7结果_附录II图II2_表2第3列.gph"

*  对表2第(4)列局部二次项回归（加入控制变量）进行检验
twoway (scatter coef drop if linear == 0 & control ==1)( rcap  up down drop if linear == 0 & control ==1), title(`"{fontface "仿宋":表2第(4)列}"') yscale(range(-0.2 0.6)) ylabel(-0.2(0.2)0.6) yline(0)  xlabel(0(2)12)  
graph save "第四章_代码7结果_附录II图II2_表2第4列.gph"

*  将上图合并、手动调整格式，后另存为 附录II图II2.gph和附录II图II2.png
gr combine "第四章_代码7结果_附录II图II2_表2第1列.gph" "第四章_代码7结果_附录II图II2_表2第2列.gph" "第四章_代码7结果_附录II图II2_表2第3列.gph" "第四章_代码7结果_附录II图II2_表2第4列.gph"
cd "D:\2024-00330+数据\2024-00330+日志文件"
graph save "Graph" 第四章_代码7结果_附录II图II2.gph    
